#Overview

OpenMRS

[OpenMRS](http://openmrs.org/) is a software platform and a reference 
application which enables design of a customized medical records system 
with no programming knowledge (although medical and systems analysis 
knowledge is required).  It is a common platform upon which medical 
informatics efforts in developing countries can be built.  The system is 
based on a conceptual database structure which is not dependent on the 
actual types of medical information required to be collected or on particular 
data collection forms and so can be customized for different uses.  

#Usage

##General

The OpenMRS charm requires a database (MySQL) and an Application server 
(Apache Tomcat) to function properly.  The mysql and tomcat7 charms already 
have the installation and configuration done for you.  

Use the following steps to set up OpenMRS:

        juju deploy mysql
        juju deploy tomcat7
        juju deploy openmrs
        juju add-relation openmrs mysql  *(This step creates the openmrs database)* 
        juju add-relation openmrs tomcat7 *(This step installs OpenMRS in Tomcat)*
        juju expose tomcat7

OpenMRS requires a database connection and will remain undeployed until the 
relation to MySQL exists.  If it the relation is removed or destroyed Tomcat 
will be shutdown, OpenMRS will be undeployed and the charm will wait for a new 
datbase connection.  

It is important to wait for OpenMRS and Tomcat to finish starting before 
accessing the web site.  Use the `juju status` command to see the status of 
the deployments and to copy the IP address and http port of Tomcat.  

##OpenMRS one time setup

Juju has created the virtual servers, installed the software, created the 
database, deployed the web application and connected these services for you. 
OpenMRS must be configured manually the first time it is used.  Refer to the 
[OpenMRS documentation](https://wiki.openmrs.org/display/docs/Step+6+-+Configure+OpenMRS) 
for details of the setup.

To setup OpenMRS browse to: **http://tomcat-host:port/openmrs**  
Replace "tomcat-host" with the public IP address from 'juju status' command.  
Replace "port" with the http_port of the Tomcat charm.  

The OpenMRS Installation Wizard is available in different languages, select 
the desired language.  
Select the green arrow (->) to continue.  

**Which type of installation do you want?**  Select **Advanced** because 
this option allows connecting to an existing database. Juju has already created 
the "openmrs" database, and any further attempts to create the database will 
result in an error.  

**Step 1** - Juju has already created and configured the MySQL database for 
OpenMRS, and should have `Database connection` filled in with the IP address of 
MySQL. `Database Driver` is optional, leave this option blank. 
Select **Yes** to the question: "Do you currently have an OpenMRS database 
installed that you would like to connect to?"  
Select the green arrow (->) to continue.  

**Step 2** - Select **Yes** for OpenMRS to **create the tables** in the 
database and decide if you want the demo data added. The database `Username` 
and `Password` should already be filled in by Juju (you are welcome)!  

Read the options on the next step and make the appropriate selections for 
upload modules and automatic deploy of database (the defaults are fine).  
Select the green arrow (->) to continue.  

Create the OpenMRS administrator's password.  
Select the green arrow (->) to continue.  

The Implementation details are optional.  
Select the green arrow (->) to continue.  

Review the operations and make sure that the wizard is not going to create 
another database (if so, go back to step 1 and select **connect to** an 
existing database).  
Select the green arrow (->) to **finish**.  

You will be brought to the OpenMRS login screen. Use admin and the OpenMRS 
administrator's password that you set up earlier and start using OpenMRS!  

##Contact Information

More information about OpenMRS can be found at:  
    - [OpenMRS](http://openmrs.org/)  
    - [OpenMRS FAQ](http://openmrs.org/about/faq/)  
    - [OpenMRS Module Repository](https://modules.openmrs.org/modules/)  
    - [Documentation OpenMRS Wiki](https://wiki.openmrs.org/display/docs/Home)  

